'use strict';

/**
 * Compiles a Date into a new Date Object
 */

const compileDate = (date, options) =>{
  let m;
  let newDate = null;
  if (options.format) {
    options.format.toLowerCase();
    if ( options.format === 'DDMMYYYY') {

        m = date.match(/^(\d{1,2})(?:\.|\-|\/|\s)(\d{1,2})(?:\.|\-|\/|\s)(\d{4})$/);
        newDate = m ? new Date(m[3] + '-' + m[2] + '-' + m[1]) : null;

      }

      else if ( options.format === 'MMDDYYYY') {

      m = date.match(/^(\d{1,2})(?:\.|\-|\/|\s)(\d{1,2})(?:\.|\-|\/|\s)(\d{4})$/);
      newDate = m ? new Date(m[3] + '-' + m[1] + '-' + m[2]) : null;

    }

      else if ( options.format === 'YYYYMMDD') {

      m = date.match(/^(\d{4})(?:\.|\-|\/|\s)(\d{1,2})(?:\.|\-|\/|\s)(\d{1,2})$/);
      newDate = m ? new Date(m[1] + '-' + m[2] + '-' + m[3]) : null;

    }
  }

  // console.log(newDate ? options.format + ' (' + m[0] + '): ' + newDate : null)
  return newDate ? newDate : null
};


module.exports = compileDate;
